<?php

namespace EdStevo\Dao\Tests;

use EdStevo\Dao\Contracts\Example as ExampleContract;
use EdStevo\Dao\Dao\Models\Example as ExampleDao;
use EdStevo\Dao\Dao\Cache\Example as ExampleDaoCache;
use Illuminate\Foundation\Testing\TestCase as LaravelTestCase;

class TestCase extends LaravelTestCase
{
    /**
     * Example Dao
     *
     * @var \EdStevo\Dao\Contracts\Example
     */
    protected $dao;

    /**
     * Creates the application.
     *
     * @return \Illuminate\Foundation\Application
     */
    public function createApplication()
    {
        $app    = new \Illuminate\Foundation\Application(
            realpath(__DIR__.'/../')
        );

        return $app;
    }

    /**
     * Setup the test environment.
     *
     * @return void
     */
    public function setUp()
    {
        parent::setUp(); // TODO: Change the autogenerated stub

        $this->bindContract();

        $this->dao  = resolve(ExampleContract::class);
    }

    /**
     * Bind the Example Dao to the cache and contract
     */
    private function bindContract()
    {
        $this->app->bind(ExampleContract::class, function($app) {

            $dao    = new ExampleDao;
            return new ExampleDaoCache($dao);
        });
    }
}